package GUI;

   
  
import java.awt.BorderLayout;   
import java.awt.Container;   
import java.awt.event.ActionEvent;   
import java.awt.event.ActionListener;   
import java.util.Observable;   
import java.util.Observer;   
import javax.swing.JButton;   
import javax.swing.JFrame;   
import javax.swing.JLabel;   
import javax.swing.JProgressBar;   
import javax.swing.JTextField;   


  

public class JanelaDownload extends JFrame implements Observer {   
    /**
	 * 
	 */
	

	//Nro de iteraes para o loop de simulao do processo   
    private static int TAM_PROCESSO = 20000000;   
       
    //Variaveis da interface   
    private JProgressBar barradeprogresso;   
    private JButton botaoOK;   
    private JTextField texto;   
    private JLabel label;   
    
    //Variavel de controle da thread do processo   
    private Thread processo;   
       
    /**  
     * Executa o processo da aplicao  
     */  
    public void executaProcesso() {   
        if(processo==null) { //Instancia a thread SE no existir uma   
            processo = new Thread(new ClasseProcesso(this));   
            processo.start();   
        } else {   
            System.out.println("O processo ainda est em execuo");   
        }      
    }   
       
    /**  
     * Construtor padro, instancia e monta objetos da tela   
     */  
    protected JanelaDownload() {   
        Container contentPane = getContentPane();   
        contentPane.setLayout(new BorderLayout());   
           
        botaoOK = new JButton("Processar");   
           
        //Listener do botao   
        botaoOK.addActionListener( new ActionListener() {   
            public void actionPerformed(ActionEvent e) {   
                   
            }              
        });   
           
        texto = new JTextField();  
        texto.setEditable(false);
        texto.setEnabled(false);
        texto.setHorizontalAlignment(javax.swing.JTextField.CENTER);
           
        label = new JLabel("Download do Arquivo");   
        label.setHorizontalAlignment(JTextField.CENTER);   
           
        barradeprogresso = new JProgressBar();   
        barradeprogresso.setMaximum(JanelaDownload.getTAM_PROCESSO());   
           
        contentPane.add(label,BorderLayout.NORTH);   
        contentPane.add(texto,BorderLayout.CENTER);   
      //  contentPane.add(botaoOK,BorderLayout.WEST);   
        contentPane.add(barradeprogresso,BorderLayout.SOUTH);   
           
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);   
           
        pack();   
    }   
       
    /**  
     * Atualiza a tela  
     * @see java.util.Observer#update(java.util.Observable, java.lang.Object)  
     * @param o Objeto que sofreu uma atualizao  
     * @param arg Argumento passado pelo objeto para seus observadores  
     */  
    public void update(Observable o, Object arg) {   
        if(arg instanceof Integer) {   
            //Seta o valor do progresso   
            barradeprogresso.setValue( ((Integer) arg).intValue());   
            texto.setText( String.valueOf(((Integer) arg).intValue()*100/JanelaDownload.getTAM_PROCESSO())+"%");   
        } else if(arg instanceof Boolean) {   
            if( ((Boolean) arg).booleanValue() ) {   
                barradeprogresso.setValue(0);   
                label.setText("Processo finalizado!");   
            }   
        }   
    }   
       
    /**  
     * Instancia e mostra a tela do usurio  
     * @param args Parmetros da linha de execuo  
     */  
  
	
	/*public static void main(String[] args) {   
       Download a = new Download(); 
       a.setVisible(true);
       a.executaProcesso();
       
    }
*/
	public static void setTAM_PROCESSO(int tAM_PROCESSO) {
		TAM_PROCESSO = tAM_PROCESSO;
	}

	public static int getTAM_PROCESSO() {
		return TAM_PROCESSO;
	}   
}  