package GUI;
import javax.swing.*;  

import pacoteCliente.Cliente;
import java.awt.event.*;  
  

public class Janela_Chat extends JFrame {  
  
	Cliente cliente;
	String fraseDigitada;
	private boolean existeFrase;
	private String usuario;
	
	//Variaveis
    JScrollPane scrollConversa;
    JScrollPane scrollUsuarios;
    JTextArea campoUsuarios;
    JTextArea campoConversa;  
    JTextField campoTexto;  
    JButton botaoEnviarMensagem;
    JPanel panelDigitarTexto;
    JLabel labelImagem;
    JLabel labelDigiteMensagem;
    ImageIcon imagemCInScript;

    //menu
    JMenuBar menuPrincipal;
    JMenu menuAcoes;
    JMenu menuArquivo;
    JMenu menuAjuda;
    JMenuItem menuEnviarArquivo;
    JMenuItem menuSair;
    JMenuItem menuAlterarNick;
    JMenuItem menuSobre;
    JMenuItem menuTopicosAjuda;
    
    //janelas
    JanelaAjuda janelaAjudaSobre;
    JanelaTopicosAjuda janelaTopicosAjuda;
    JanelaDownload janelaDownload;
    
    JFileChooser abridorArquivo;
    
    public Janela_Chat(String usuario) {  
       
    	existeFrase = false;
    	this.usuario = usuario;
    	
    	this.configurarComponentes();
    	this.setComponentes();
    	
    	this.setTitle("CIn Script");
    	this.setSize(640, 740);
    	
    	this.setLocationRelativeTo(null);  
    	this.setLayout(null);
    	this.setVisible(true);
    	this.setDefaultCloseOperation(EXIT_ON_CLOSE);  
    	
    	this.cliente = null;
    	this.addComponentes();
        
    }  
    
    public void setCliente(Cliente cliente){
    	this.cliente = cliente;
    }
    
    //este metodo inicializa e configura todos os componentes do Frame
    public void configurarComponentes(){
    	//imagem
    	this.imagemCInScript = new ImageIcon("imagem.jpg");
    	this.labelImagem = new JLabel();
    	this.labelImagem.setIcon(this.imagemCInScript);
    	
    	//campo onde aparece a conversa
    	this.campoConversa = new JTextArea(); 
    	this.campoConversa.setEditable(false);
    	this.scrollConversa = new JScrollPane(campoConversa);  
    	
    	//campo onde aparece a lista de usuarios logados
    	this.campoUsuarios = new JTextArea();
    	this.scrollUsuarios = new JScrollPane(this.campoUsuarios);
    	this.campoUsuarios.setEditable(false);

    	//painel onde esta o campo para digitar mensagem e envia-las
    	this.labelDigiteMensagem = new JLabel("Digite aqui sua mensagem: ");
    	this.campoTexto = new JTextField(); 
    	this.campoTexto.addKeyListener(new EnviarMensagemEnter());
    	this.botaoEnviarMensagem = new JButton("Enviar");   
        this.botaoEnviarMensagem.addActionListener(new BotaoEnviarMensagem());
        
        //menu
        this.menuPrincipal = new JMenuBar();
        this.menuArquivo = new JMenu("Arquivo");
        this.menuAcoes = new JMenu("Aes");
        this.menuAjuda = new JMenu("Ajuda");
        
        this.menuEnviarArquivo = new JMenuItem("Enviar Arquivo");
        this.menuSair = new JMenuItem("Sair");
        
        this.menuAlterarNick = new JMenuItem("Alterar Nick");
        this.menuSobre = new JMenuItem("Sobre CIn Script");
        this.menuTopicosAjuda = new JMenuItem("Tpicos de Ajuda");
        
        this.menuPrincipal.add(this.menuArquivo);
        this.menuPrincipal.add(this.menuAcoes);
        this.menuPrincipal.add(this.menuAjuda);
        this.menuArquivo.add(this.menuSair);
        this.menuAcoes.add(this.menuEnviarArquivo);
        this.menuAcoes.add(this.menuAlterarNick);
        this.menuAjuda.add(this.menuSobre);
        this.menuAjuda.add(this.menuTopicosAjuda);
        
        this.menuSair.addActionListener(new MenuItemSair());
        this.menuSobre.addActionListener(new MenuItemAjudaSobre());
        this.menuTopicosAjuda.addActionListener(new MenuItemTopicosAjuda());
        this.menuEnviarArquivo.addActionListener(new MenuItemEnviarArquivo());
    }
   
    //este metodo seta os tamanhos e as posies dos componentes no frame
    public void setComponentes(){
    	this.scrollConversa.setBounds(0, 105, 450, 500);
    	this.scrollUsuarios.setBounds(450, 105, 183, 500);
    	this.labelImagem.setBounds(0, 5, 700, 100);
    	this.labelDigiteMensagem.setBounds(20, 610, 200, 25);
    	this.campoTexto.setBounds(20, 640, 430, 25);
    	this.botaoEnviarMensagem.setBounds(480, 640, 100, 25);
    }
    
    public void addComponentes(){
    	this.setJMenuBar(this.menuPrincipal);
    	this.add(this.scrollConversa);
    	this.add(this.scrollUsuarios);
    	this.add(this.labelImagem);
    	this.add(this.labelDigiteMensagem);
    	this.add(this.campoTexto);
    	this.add(this.botaoEnviarMensagem);
    }
    private class BotaoEnviarMensagem implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			fraseDigitada = campoTexto.getText();
			cliente.escrever(fraseDigitada);
			existeFrase = true;
			if(!fraseDigitada.equals("")){
				escreverNaTela(usuario,fraseDigitada);
				campoTexto.setText("");
			}else{
				
			}
			
		}

		
    }
    
   
    
    private class MenuItemSair implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			dispose();
			
		}

		
    	
    }
    private class MenuItemTopicosAjuda implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			janelaTopicosAjuda = new JanelaTopicosAjuda();
			
		}

		
    	
    }
    private class MenuItemAjudaSobre implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
			janelaAjudaSobre = new JanelaAjuda();
			
		}

    	

    }
    
    private class EnviarMensagemEnter implements KeyListener{

		public void keyPressed(KeyEvent e) {
			if(e.getKeyCode() == KeyEvent.VK_ENTER){
				fraseDigitada = campoTexto.getText();
				cliente.escrever(fraseDigitada);
				existeFrase = true;
				if(!fraseDigitada.equals("")){
					escreverNaTela(usuario,fraseDigitada);
					campoTexto.setText("");
				}else{
					
				}
			}
			
		}

		public void keyReleased(KeyEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void keyTyped(KeyEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		
    	
    }
    
    private class MenuItemEnviarArquivo implements ActionListener {

		public void actionPerformed(ActionEvent arg0) {
			abridorArquivo = new JFileChooser();
			int valorRetorno = abridorArquivo.showDialog(null, "Open");
			if(valorRetorno == JFileChooser.APPROVE_OPTION){
				//retorna o caminho do arquivo
				String diretorio = abridorArquivo.getSelectedFile().getAbsolutePath();
				System.out.println(diretorio);
				cliente.enviarArquivo(diretorio);
				//TODO modificar velocidade da barra de acordo com o tamanho do arquivo e da taxa de tranferncia
				janelaDownload = new JanelaDownload();
				janelaDownload.setVisible(true);
				janelaDownload.executaProcesso();
			}else if (valorRetorno == JFileChooser.CANCEL_OPTION) {
				return; 
			}
		}

		
    }

    public String getFraseDigitada(){
    	String retorno = "";
    	while(!existeFrase){
    		retorno = this.fraseDigitada;
    	}
    	existeFrase = false;
    	return retorno;
    }
    public void escreverNaTela(String nome,String frase){
    	campoConversa.setText(campoConversa.getText() + nome+ " diz: " + frase + "\n");
    	
    }
    
    public void escreverLogin(String[] nome){
    	String logins = "";
    	for (int i = 0; i < nome.length; i++) {
    		logins = logins + nome[i] + "\n";
		}
    	this.campoUsuarios.setText(logins);
    	
    }
  
    
}  