package pacoteCliente;

import java.io.*;
import java.net.*;

import pacoteConexaoControle.ThreadEsperarConexaoControleEntrada;
import pacoteEnviarDados.RepositorioThreadMandarArquivo;
import pacoteReceberDados.ThreadAtualizarBuffer;

import GUI.Entrada;

public class Cliente {
	
	private RepositorioConexoes repConexoes;
	private RepositorioThreadMandarArquivo repMandarArquivo;
	private Usuario[] repUsuarios;
	private String nome;
	private int portaChat;
	private int portaDados;
	private int portaControle;
	private Entrada gui;
	
	public Cliente(Entrada gui){
		this.gui = gui;
		this.repConexoes = new RepositorioConexoes(this);
		this.repMandarArquivo = new RepositorioThreadMandarArquivo();
		this.repUsuarios = null;
	}
	
	public void rodar(){
		BufferedReader entradaDoServidor = null;
		DataOutputStream saidaParaServidor = null;
		
		//System.out.println("Digite o ip do servidor:");
		//String servidor = new Scanner(System.in).next();
		//System.out.println("\nDigite seu login:");
		//String login = new Scanner(System.in).next();
		String login = gui.nomeUsuario;
		try{
			Socket clienteSocket = new Socket("172.17.68.46",5000);
			
			//pegando meu proprio ip
			InetAddress myself = InetAddress.getLocalHost();
			System.out.println("Local host eh " + myself.getHostName() +
					" e o IP eh " + myself.getHostAddress());
			String meuIP = myself.getHostAddress();
			
			//logando no sistema (e mandando junto meu ip, pois estava dando
			//problema p pegar o ip la no servidor)
			saidaParaServidor = new DataOutputStream(clienteSocket.getOutputStream());
			saidaParaServidor.writeBytes(login+"#"+meuIP+"\n");

			//pegando a resposta do servidor (se foi autorizado ou nao)
			entradaDoServidor = new BufferedReader(new InputStreamReader(clienteSocket.getInputStream()));
			int autorizado = entradaDoServidor.read();
			
			if(autorizado != 1) System.out.println("usuario nao encontrado \n");
			//} else {  //foi autorizado!
			
			this.nome = login;
			this.portaChat = entradaDoServidor.read();
			this.portaDados = entradaDoServidor.read();
			this.portaControle = entradaDoServidor.read();
			
			//recebendo o ping do servidor
			int ping = entradaDoServidor.read();
			//respondendo ao ping
			saidaParaServidor.write(ping);
			
			//pegando o numero de clientes conectados.
			int numConectados = entradaDoServidor.read();
			//pegando lista dos clientes conectados
			for(int i = 0; i < numConectados; i++){
				String valores = entradaDoServidor.readLine();
				String[] infoUsuarios = valores.split("#");//infoUsuarios = NOME, IP, porta p chat, porta p dados;	
				int portaChat = entradaDoServidor.read();
				int portaDados = entradaDoServidor.read();
				int portaControle = entradaDoServidor.read();
				this.repConexoes.adicionarNovaConexao(infoUsuarios[0],infoUsuarios[1],
						portaChat,portaDados,portaControle, this);
			}			
			
		} catch (Exception e){
			System.out.println("erro ao inicializar o cliente");
			e.printStackTrace();
		}
		ThreadAtualizar atualizar = new ThreadAtualizar(this,entradaDoServidor,saidaParaServidor);
		ThreadEsperarConexoesEntrada conexoesEntrada = new ThreadEsperarConexoesEntrada(this,this.portaChat);
		ThreadEsperarConexaoControleEntrada conexoesControleEntrada = new ThreadEsperarConexaoControleEntrada(this,this.portaControle);
		ThreadAtualizarBuffer threadReceberDados = new ThreadAtualizarBuffer(this,this.portaDados);
		/*do{
			//textoDigitado = new Scanner(System.in).useDelimiter("\n").next();
			textoDigitado = gui.getFraseDigitada();
			System.out.println(textoDigitado);
			//this.imprimirNaTela(this.nome,textoDigitado);
		} while(!textoDigitado.equals("Adeus\n"));
		atualizar.interrupt();
		conexoesEntrada.interrupt();
		this.repConexoes.finalizar();*/
	}
	
	public Usuario[] getRepUsuarios() {
		return repUsuarios;
	}
	
	public void escrever(String textoDigitado){
		this.repConexoes.escrever(textoDigitado);
	}

	public void setRepUsuarios(Usuario[] repUsuarios) {
		this.repUsuarios = repUsuarios;
	}

	public RepositorioConexoes getRepConexoes() {
		return repConexoes;
	}
	
	public void atualizar(){
		
	}
	public void imprimirNaTela(String nome, String fraseDeEntrada){
		gui.escreverNaTela(nome,fraseDeEntrada);
	}
	public String getNome(){
		return this.nome;
	}
	public int getPortaDados() {
		return portaDados;
	}

	public void setPortaDados(int portaDados) {
		this.portaDados = portaDados;
	}

	public void escreverLogin(String[] usuarios){
		gui.escreverLogins(usuarios);
	}
 
	public void mandarAck(String ip, boolean flag, int id, boolean ping, int sequencia) {
		this.repConexoes.mandarAck(ip,flag,id,ping,sequencia);
	}

	public void setAck(int id, boolean flag, int numSeq) {
		this.repMandarArquivo.setAck(id,flag,numSeq);
		
	}

	public void enviarArquivo(String diretorio) {
		this.repMandarArquivo.inserir(this,diretorio);
	}

	public void setGuiAcabouEnvio(int idArquivo) {

		System.out.println("Transaferncia Terminada");
		
		// TODO avisar a gui q o arquivo acabou de ser enviado!
	}
}
