package pacoteCliente;

import pacoteConexaoControle.ConexaoControleSaida;
import pacoteConexaoControle.ThreadConexaoControleEntrada;

public class Conexoes {
	
	private String nome;
	private String ip;
	private ThreadConexaoSaida saida;
	private ThreadConexaoEntrada entrada;
	private ThreadConexaoControleEntrada controleEntrada;
	private ConexaoControleSaida controleSaida;
	private boolean valido;
	private int portaChat;
	private int portaDados;
	private int portaControle;

	public Conexoes(String nome,String ip,int portaChat,int portaDados, int portaControle, Cliente cliente) {
		this.nome = nome;
		this.portaChat = portaChat;
		this.portaDados = portaDados;
		this.portaControle = portaControle;
		this.ip = ip;
		this.entrada = null;
		this.saida = new ThreadConexaoSaida(cliente,ip,portaChat);
		this.controleSaida = new ConexaoControleSaida(this.ip,portaControle);
		this.valido = true;  //usado para a atualizacao das conexoes ativas
	}

	public String getIp() {
		return ip;
	}

	public int getPortaChat() {
		return portaChat;
	}

	public int getPortaDados() {
		return portaDados;
	}
	
	public int getPortaControle(){
		return portaControle;
	}

	public boolean isValido() {
		return valido;
	}

	public void setValido(boolean valido) {
		this.valido = valido;
	}

	public String getNome() {
		return nome;
	}

	public void setEntrada(ThreadConexaoEntrada entrada) {
		this.entrada = entrada;
	}
	
	public void encerrarConexao(){
		entrada.interrupt();
		saida.interrupt();
		controleEntrada.interrupt();
	}
	
	public void escrever(String frase){
		this.saida.escrever(frase);
	}

	public void mandarAck(boolean flag, int id, boolean ping, int sequencia) {
		this.controleSaida.mandarAck(flag,id,ping,sequencia);
	}

	public void setControleEntrada(ThreadConexaoControleEntrada novaEntrada) {
		this.controleEntrada = novaEntrada;
	}
}
