package pacoteEnviarDados;

import java.io.IOException;

public class GeradorDePacotes {

	private String ipDestino;
	private int portaDestino;
	private String meuIP;
	private int portaFonte;
	private int proxPacote;
	private int ultimoPacote;
	private int tamanhoPacote;
	private GeradorDeCabecalho geradorDeCabecalho;
	private boolean primeiroPacote;
	private GerenciadorDeArquivo gerenciadorDeArquivo;
	private int idArquivo;
	private int tamanhoArquivo;
	
	public GeradorDePacotes(String ipDestino, int portaDestino, String meuIP, int portaFonte, String diretorio,int idArquivo) throws IOException{
		this.ipDestino = ipDestino;
		this.portaDestino = portaDestino;
		this.meuIP = meuIP;
		this.portaFonte = portaFonte;
		this.proxPacote = 0;
		this.idArquivo = idArquivo;
		this.tamanhoPacote = 150; //tamanho de um pacote!
		this.primeiroPacote = true; //indica se o q vai ser mandado eh o primeiro pacote (contem apenas o nome do arquivo na parte de dados)
		this.geradorDeCabecalho = new GeradorDeCabecalho();
		this.gerenciadorDeArquivo = new GerenciadorDeArquivo(diretorio,128); //128B eh o tam do trecho de dados do pacote
		this.ultimoPacote = this.gerenciadorDeArquivo.getNumPacotesTotal(); // -1 pois o primeiro pacote eh indexado como 0!
	}

	public boolean terminou() {
		return (proxPacote == ultimoPacote);
	}
	
	public byte[] proximoPacote() throws IOException {
		byte[] retorno = new byte[tamanhoPacote];
		int comprimento = gerenciadorDeArquivo.getNumPacotesTotal();
		//modificando os campos do cabealho necessarios
		if(primeiroPacote){
			//o primeiro pacote mandara o nome do arquivo a ser recebido (na parte de dados)
			byte[] dados = gerenciadorDeArquivo.getNomeArquivo();
			this.tamanhoArquivo = dados.length;
			byte[] cabecalho = geradorDeCabecalho.gerar(portaFonte, portaDestino, meuIP, ipDestino, proxPacote, comprimento,true,idArquivo, tamanhoArquivo);
			System.arraycopy(cabecalho,0, retorno, 0, 22);
			System.arraycopy(dados, 0, retorno, 22, dados.length);
			this.primeiroPacote = false;
		} else {
			byte[] dados = gerenciadorDeArquivo.getDados(proxPacote);
			this.tamanhoArquivo = dados.length;
			byte[] cabecalho = geradorDeCabecalho.gerar(portaFonte, portaDestino, meuIP, ipDestino, proxPacote, comprimento,false,idArquivo, this.tamanhoArquivo);
			System.arraycopy(cabecalho,0, retorno, 0, 22);
			System.arraycopy(dados, 0, retorno, 22, dados.length);
			this.proxPacote++; //somente a parte referente aos dados
		}
		return retorno;
	}
}
