package pacoteEnviarDados;

import java.io.*;

import apoio.Conversor;

public class GerenciadorDeArquivo {

	private String diretorio;
	private int tamPacote;
	private int blocoAtual;
	private byte[] blocoDoArquivo;
	private int tamanhoBloco;
	
	public GerenciadorDeArquivo(String diretorio, int tamanhoPacote) throws IOException{
		this.diretorio = diretorio;
		this.tamPacote = tamanhoPacote;
		this.blocoAtual = 0;
		this.tamanhoBloco = 4194304;  //4194304 = 4MB
		this.blocoDoArquivo = this.pegarBloco(0); //pegando ja o primeiro bloco...
		
		
		
	}
	
	private byte[] pegarBloco(int bloco) throws IOException {
		byte[] retorno;
		long offset = ((long)bloco) * ((long)tamanhoBloco);
		
		File arquivo = new File(this.diretorio);
		FileInputStream arquivoStream = new FileInputStream(this.diretorio);
		arquivoStream.skip(offset);
		if(arquivo.length() - offset >= tamanhoBloco){
			retorno = new byte[tamanhoBloco];
			arquivoStream.read(retorno, 0, tamanhoBloco);
		} else { //ker dizer q o bloco q estou tentando pegar eh menor q tamanhoBloco
			retorno = new byte[(int)(arquivo.length() - offset)];
			arquivoStream.read(retorno, 0, (int)(arquivo.length() - offset));
		}
		arquivoStream.close();
		return retorno;
	}
	
	//Metodo q retorna o tanto de 'pacotes' que aquele arquivo tem
	public int getNumPacotesTotal(){
		File file = new File(this.diretorio);
		int retorno = (int)(file.length()/(long)this.tamPacote);
		if((file.length()%(long)this.tamPacote) != 0) retorno++; //a divisao arredonda p baixo ;/
		return  retorno;
	}
	
	//metodo que, dado o numero de sequencia do 'pacote' requerido, 
	//retorna o trecho de dados para ser juntado ao pacote.
	public byte[] getDados(int numSequencia) throws IOException{
		//TODO inicializar retorno!!
		byte[] retorno;
		long offset = (long)numSequencia * (long)this.tamPacote;
		int numBytesALer;
		
		if(this.getNumPacotesTotal() == numSequencia + 1){ //significa que eh o ultimo pacote(possivelmente nao completa 1 pacote inteiro)
			int tamanho = (int)((new File(this.diretorio)).length() - offset);
			retorno = new byte[tamanho];
			numBytesALer = tamanho;
		} else {
			retorno = new byte[128];
			numBytesALer = 128;
		}
		
		if(offset >= ((this.blocoAtual+1) * tamanhoBloco)){
			this.blocoAtual = (int)(offset / tamanhoBloco);
			this.blocoDoArquivo = this.pegarBloco(this.blocoAtual); //atualizando o bloco requerido
		} 
		int posicao = (int)(offset % tamanhoBloco);
		System.arraycopy(blocoDoArquivo, posicao, retorno, 0, numBytesALer);
		return retorno;
	}

	public byte[] getNomeArquivo() {
		String nome = (new File(this.diretorio)).getName(); //pega apenas o nome do arquivo (sem todo o diretorio)
		byte[] retorno = null;
		retorno = (new Conversor()).stringToByte(nome);
		return retorno;
	}
}
