package pacoteEnviarDados;

import java.net.DatagramSocket;

public class Janela {

	private Pacote[] janela;
	private int proxPosicao;
	private int tamanho;
	private long timeout;
	
	public Janela(int tamanho){
		this.tamanho = tamanho;
		this.janela = new Pacote[this.tamanho];
		this.timeout = 1000; //TODO: pesquisar um bom numero p timout
	}
	
	public synchronized void inserirPacote(byte[] pacote,DatagramSocket socket,String IPDestino,int portaDestino){
		if(this.temVaga()){
			this.janela[proxPosicao] = new Pacote(this,pacote,timeout,socket,IPDestino,portaDestino);
			//this.janela[proxPosicao].iniciar();
			this.proxPosicao++;
		}
	}

	public boolean temVaga(){
		return (this.proxPosicao < this.tamanho);
	}

	private boolean existePacote(int sequencia, boolean flag){
		boolean achou = false;
		int posicao = 0;
		while(!achou && posicao < proxPosicao){
			if((janela[posicao].getSequencia() == sequencia) && (janela[posicao].isFlag() == flag)){
				achou = true;
			}
			posicao++;
		}
		return achou;
	}
	private int procurar(int sequencia, boolean flag){
		boolean achou = false;
		int posicao = 0;
		while(!achou && posicao < proxPosicao){
			if((janela[posicao].getSequencia() == sequencia) && (janela[posicao].isFlag() == flag)){
				achou = true;
			}
			posicao++;
		}
		//if(!achou) posicao = 0; //assim, se nao achar retornara -1
		return posicao-1;
	}
	//seta o ACK no pacote indicado(para ele terminar o q estava fazendo..)
	 //e remove o objeto da janela.
	public synchronized void setAck(int sequencia, boolean flag){		
		if(existePacote(sequencia,flag)){
			int posicao = procurar(sequencia,flag);
			
			if(posicao != -1){
				this.janela[posicao].setAck(true);
				synchronized(this.janela[posicao]){
					this.janela[posicao].notify();
				}
				this.remover(posicao);
			}
		}
	}
	private synchronized void remover(int posicao) {
		if(posicao != proxPosicao){//ker dizer q ele nao eh o ultimo (se for o ultimo ele so vai dminuir proxPosicao)
			for(int i = posicao; i < proxPosicao-1;i++){
				this.janela[i] = this.janela[i+1];
			}
		}
		proxPosicao--;
	}
	

	public long getTimeout() {
		return timeout;
	}

	public void setTimeout(long timeout) {
		for(int i = 0;i < proxPosicao;i++){
			this.janela[i].setTimeout(timeout);
		}
	}

	public int getTamanho() {
		return tamanho;
	}

	public void setTamanho(int tamanho) {
		this.tamanho = tamanho;
	}
}
