package pacoteEnviarDados;

import java.io.IOException;
import java.net.*;

import apoio.Conversor;


public class Pacote extends Thread {
	
	private byte[] pacote;
	private boolean ack;
	private DatagramSocket clientSocket;
	private InetAddress ipDestino;
	private int portaDestino;
	private long timeout;
	private int sequencia;
	private boolean flag;
	private Janela janela;
	int nPacotesEnviados;
	
	public Pacote(Janela janela,byte[] pacote,long timeout,DatagramSocket clientSocket, String IPDestino,int portaDestino){
		this.janela = janela;
		this.pacote = pacote;
		this.janela = janela;
		this.flag = (new Conversor()).getFlag(pacote[20]);
		this.ack = false;
		this.clientSocket = clientSocket;
		nPacotesEnviados = 0;
		try {
			this.ipDestino = InetAddress.getByName(IPDestino);
		} catch (UnknownHostException e) {
			System.out.println("erro na thread 'pacote'");
			e.printStackTrace();
		}
		this.portaDestino = portaDestino;
		this.timeout = timeout;
		//pegando o numero de sequencia do pacote:
		this.sequencia = (new Conversor()).byteArrayToInt(pacote, 12, 4);
		start();
	}
	
	public void run(){
		DatagramPacket sendPacket = new DatagramPacket(pacote, pacote.length, ipDestino, portaDestino);
		while(!ack){
			try {
				this.clientSocket.send(sendPacket);
				synchronized (this) {
					wait(timeout);   //esperando o recebimento do ack!
				}				
			} catch (InterruptedException e) {
				System.out.println("thread pacote foi interrompida!");
				e.printStackTrace();
			} catch (IOException e) {
				System.out.println("erro ao tentar mandar o pacote");
				e.printStackTrace();
			}
		}
		nPacotesEnviados++;
		if(nPacotesEnviados%100 == 0){
			System.out.println("Pacote "+ sequencia+" terminou");
		}
		//
	}

	public boolean isAck() {
		return ack;
	}

	public void setAck(boolean ack) {
		this.ack = ack;
	}

	public long getTimeout() {
		return timeout;
	}

	public void setTimeout(long timeout) {
		this.timeout = timeout;
	}
	public int getSequencia(){
		return this.sequencia;
	}

	public byte[] getPacote() {
		return pacote;
	}

	public void setPacote(byte[] pacote) {
		this.pacote = pacote;
	}

	public DatagramSocket getClientSocket() {
		return clientSocket;
	}

	public void setClientSocket(DatagramSocket clientSocket) {
		this.clientSocket = clientSocket;
	}

	public InetAddress getIpDestino() {
		return ipDestino;
	}

	public void setIpDestino(InetAddress ipDestino) {
		this.ipDestino = ipDestino;
	}

	public int getPortaDestino() {
		return portaDestino;
	}

	public void setPortaDestino(int portaDestino) {
		this.portaDestino = portaDestino;
	}

	public boolean isFlag() {
		return flag;
	}

	public void setFlag(boolean flag) {
		this.flag = flag;
	}

	public void setSequencia(int sequencia) {
		this.sequencia = sequencia;
	}
	
}
