package pacoteEnviarDados;

import java.io.IOException;
import java.net.*;
import java.util.Scanner;

import pacoteCliente.Cliente;
class IdentificadorThread {
	private int id;
	
	public IdentificadorThread(int id){
		this.id = id;
	}
	public int getIdArquivo(){
		return this.id;
	}
	
}
public class ThreadMandarArquivo extends Thread {

	private Cliente cliente;
	private String ipDestino;
	private int portaDestino;
	private String diretorio;
	private Janela janela;
	private int idArquivo;

	public ThreadMandarArquivo(Cliente cliente,String ipDestino,int portaDestino,String diretorio,int idArquivo){
		this.cliente = cliente;
		this.ipDestino = ipDestino;
		this.portaDestino = portaDestino;
		this.diretorio = diretorio;
		this.idArquivo = idArquivo;
		this.janela = new Janela(128); //janela de 128 pacotes
		start();
	}
	
	public void run(){
		try {
			DatagramSocket clientSocket = new DatagramSocket();
			
			InetAddress myself = InetAddress.getLocalHost();
			String meuIP = myself.getHostAddress();
			GeradorDePacotes geradorDePacotes = new GeradorDePacotes(ipDestino,portaDestino,meuIP,cliente.getPortaDados(),diretorio,idArquivo); 
			while(!geradorDePacotes.terminou()){   //enquanto ainda ha pacote a ser enviado
				if(janela.temVaga()){
					byte[] pacote = geradorDePacotes.proximoPacote();//proximo pacote a ser enviado
					janela.inserirPacote(pacote,clientSocket,ipDestino,portaDestino);
				}
			}
		} catch (SocketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} //socket UDP
		catch (UnknownHostException e) {
			System.out.println("erro ao tentar pegar o proprio ip!");
			e.printStackTrace();
		} catch (IOException e) {
			System.out.println("erro no gerador de pacotes..");
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		String teclado;
		Scanner in = new Scanner(System.in);
		teclado = in.nextLine();
		new ThreadMandarArquivo(new Cliente(null),"172.17.67.12",5002,teclado,1);
		new ThreadMandarArquivo(new Cliente(null),"172.17.67.12",5002,teclado,2);
	}
	public Janela getJanela(){
		
		return this.janela;
		
	}
	
	public int getIdArquivo(){
		return this.idArquivo;
	}
	public boolean equals(Object idThread){
		//System.out.println("Thread igual ->"+(this.idArquivo == ((ThreadMandarArquivo)thread).idArquivo));
		//System.out.println(this.idArquivo == ((IdentificadorThread)idThread).getId());
		return (this.idArquivo == ((IdentificadorThread)idThread).getIdArquivo());
	}
}
