package pacoteReceberDados;

public class Buffer {

	private byte[] buffer;
	private int tamanho;
	private int proxPosicao;
	private int tamanhoDeUmPacote;
	
	public Buffer(int tamanho,int tamanhoDeUmPacote){
		this.tamanho = tamanho;
		this.buffer = new byte[tamanho];
		this.proxPosicao = 0;
		this.tamanhoDeUmPacote = tamanhoDeUmPacote;
	}

	public synchronized boolean haConteudo() {
		return (this.proxPosicao != 0);
	}

	public synchronized byte[] next() {
		byte[] retorno = new byte[tamanhoDeUmPacote];
		System.arraycopy(buffer, 0, retorno, 0, this.tamanhoDeUmPacote);
		//apagando a parte lida do buffer
		byte[] temp = new byte[tamanho];
		System.arraycopy(buffer, tamanhoDeUmPacote, temp, 0, proxPosicao-tamanhoDeUmPacote);
		System.arraycopy(temp, 0, buffer, 0, temp.length);
		this.proxPosicao = proxPosicao - tamanhoDeUmPacote;
		
		return retorno;
	}

	public synchronized void inserir(byte[] pacoteLido) {
		if((this.proxPosicao + this.tamanhoDeUmPacote) < this.tamanho){
			System.arraycopy(pacoteLido, 0, buffer, proxPosicao, pacoteLido.length);
			this.proxPosicao = this.proxPosicao+this.tamanhoDeUmPacote;
		}
		
	}
}
