package pacoteReceberDados;

import pacoteCliente.Cliente;
import apoio.Arquivo;

public class Janela {

	private String ipFonte;
	private int idArquivo;
	private Arquivo arquivo;
	private Cliente cliente;
	private int numSequenciaInicial; //numero de sequencia do primeiro pacote da janela
	private int tamanho;
	private Dados[] repositorioDados;
	private int ultimoNumSeq;
	
	public Janela(Cliente cliente,String ip, int id,int posicao,int tamanhoJanela){
		String nome = String.valueOf(posicao);
		this.arquivo = new Arquivo(ip+"_"+nome);
		this.ipFonte = ip;
		this.idArquivo = id;
		this.cliente = cliente;
		this.numSequenciaInicial = 0;
		this.tamanho = tamanhoJanela;
		this.repositorioDados = new Dados[this.tamanho];
	}
	
	public synchronized void adicionar(byte[] pacote){
		Descompactador descomp = new Descompactador(pacote);
		this.ultimoNumSeq = descomp.getComprimento();
		int numSeqPacote = descomp.getSequencia();
		String ip = descomp.getIpFonte();
		if((numSeqPacote >= numSequenciaInicial) && (numSeqPacote <= (numSequenciaInicial + tamanho - 1))){
			int posicao = numSeqPacote % tamanho; //vai me dar a posicao do pacote me minha janela
			if((this.repositorioDados[posicao] == null) || (!this.repositorioDados[posicao].isValidade())){ //ou seja, se nao tem nada ali ou nao ja recebeu este pacote..
				this.repositorioDados[posicao] = new Dados();
				this.repositorioDados[posicao].setDados(descomp.getDados());
				this.repositorioDados[posicao].setValidade(true);
				this.cliente.mandarAck(ip,false,this.idArquivo,false,numSeqPacote);
				if(numSeqPacote == numSequenciaInicial){
					this.gravarNoArquivo();
				}
			}
		}
	}

	private synchronized void gravarNoArquivo() {
		int numPacotes = 0;
		int posicao = this.numSequenciaInicial % tamanho;
		boolean taCheio = false;
		while(this.repositorioDados[posicao] != null && this.repositorioDados[posicao].isValidade() && !taCheio){
			numPacotes++;
			posicao = (posicao+1)%tamanho;
			if(numPacotes == this.tamanho) //ker dizer q todos os dados sao validos
				taCheio = true;
		}
		
		byte[] blocoDeDados = new byte[0]; //128 eh o tamanho de um pacote!
		int posicaoArray = numSequenciaInicial;
		for(int i = 0;i < numPacotes;i++ ){
			posicaoArray = (this.numSequenciaInicial+i) % tamanho;
			byte[] dados = this.repositorioDados[posicaoArray].getDados();
			int tamanhoDados = dados.length;
			int tamanhoDadosBloco = blocoDeDados.length;
			
			byte[] temp = new byte[tamanhoDados + tamanhoDadosBloco];
			System.arraycopy(blocoDeDados, 0, temp, 0, blocoDeDados.length);
			System.arraycopy(dados, 0, temp, blocoDeDados.length, dados.length);

			this.repositorioDados[posicaoArray].setValidade(false);
			//System.out.println(dados.length);
			blocoDeDados = temp;
			//this.numSequenciaInicial++;
		}
		this.numSequenciaInicial = numSequenciaInicial+numPacotes;
		if(this.numSequenciaInicial == this.ultimoNumSeq){
			cliente.setGuiAcabouEnvio(this.idArquivo);
		}
		this.arquivo.setBloco(blocoDeDados, blocoDeDados.length);
		
	}
	
	public void setNome(String nome){
		this.arquivo.setarNome(nome);
	}
	
	public String getIpFonte() {
		return ipFonte;
	}

	public int getIdArquivo() {
		return idArquivo;
	}
}
