package pacoteReceberDados;

import apoio.Conversor;
import pacoteCliente.Cliente;

public class RepositorioJanelas {

	
	private Janela[] repositorio;
	private int proxPos;
	private Cliente cliente;
	
	public RepositorioJanelas(Cliente cliente,int tamanho){
		this.cliente = cliente;
		this.repositorio = new Janela[tamanho];
		this.proxPos = 0;
	}
	
	public void adicionar(byte[] p){
		Descompactador desc = new Descompactador(p);
		int tamanhoDados = 22+desc.getTamanhoArquivo(); //tamanho total do pacote
		byte[] pacote = new byte[tamanhoDados];
		System.arraycopy(p, 0, pacote, 0, tamanhoDados);
		String ip = desc.getIpFonte();
		int id = desc.getIdArquivo();
		if(existeJanela(ip,id)){
			int posicao = procurarJanela(ip,id);
			if(desc.getFlagIdArquivo()){ //se true ker dizer q o pacote eh o q contem o nome do arquivo
				String nome = (new Conversor()).byteToString(desc.getDados());
				repositorio[posicao].setNome(nome);
				this.cliente.mandarAck(ip,true,id,false,0);
			} else {
				repositorio[posicao].adicionar(pacote);
			}
		} else {

			repositorio[proxPos] = new Janela(this.cliente,ip,id,proxPos,256); //128  o tamanho da janela 

			if(desc.getFlagIdArquivo()){
				String nome = (new Conversor()).byteToString(desc.getDados());
				repositorio[proxPos].setNome(nome);
			} else {
				repositorio[proxPos].adicionar(pacote);
			}
			this.proxPos++;
		}
	}

	private int procurarJanela(String ip, int id) {
		boolean achou = false;
		int posicao = 0;
		while(!achou && posicao < this.proxPos){
			String ipRepositorio = this.repositorio[posicao].getIpFonte();
			int idRepositorio = this.repositorio[posicao].getIdArquivo();
			if((ipRepositorio.equals(ip)) && (idRepositorio == id)){
				achou = true;
			} else {
				posicao++;
			}
		}
		if(posicao == this.proxPos){
			posicao = -1;
		}
		return posicao; //flag -1 indicara erro (janela nao encontrada)
	}

	private boolean existeJanela(String ip, int id) {
		boolean achou = false;
		int posicao = 0;
		while(!achou && posicao < this.proxPos){
			String ipRepositorio = this.repositorio[posicao].getIpFonte();
			int idRepositorio = this.repositorio[posicao].getIdArquivo();
			if((ipRepositorio.equals(ip)) && (idRepositorio == id)){
				achou = true;
			}
			posicao++;
		}
		return achou;
	}
	
}
