package pacoteServidor;

import java.io.*;
import java.net.*;

public class ConectarNovoCliente extends Thread {

	private Servidor servidor;
	private Socket socket;
	private BufferedReader entrada;
	private DataOutputStream saida;
	
	public ConectarNovoCliente(Servidor servidor ,Socket sock){
		this.servidor = servidor;
		this.socket = sock;
		start();
	}

	public DataOutputStream getSaida() {
		return saida;
	}

	public Servidor getServidor() {
		return servidor;
	}

	public BufferedReader getEntrada() {
		return entrada;
	}

	public Socket getSocket() {
		return socket;
	}
	
	
	public void run(){
		try{
			entrada = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			String userEIP = entrada.readLine();
			String[] temp = userEIP.split("#");
			String user = temp[0];
			String ip = temp[1];
			
			boolean existe = this.servidor.existeUsuario(user); 
			saida = new DataOutputStream(socket.getOutputStream());
			int resposta = 0;
			if(existe) resposta = 1;
			saida.write(resposta);
			
			if(existe){
				int portaChat = servidor.getRepositorio().getPortaChat(user);
				int portaDados = servidor.getRepositorio().getPortaDados(user);
				int portaControle = servidor.getRepositorio().getPortaControle(user);
				saida.write(portaChat);
				saida.write(portaDados);
				saida.write(portaControle);
				this.servidor.setHost(user,ip);

				//mandando um ping p o cliente p saber se ele ainda esta conectado
				//e mandar a lista atual dos conectados p os clientes.
				new PingEAtualizar(this,user);
				synchronized(this) {  
				this.wait();
				}
				
				//se saiu do while ker dizer q desconectou!!
				this.servidor.setHost(user,null);
			}
			socket.close();
			System.out.println("socket fechado com sucesso");
			} catch (Exception e){
				System.out.println("erro na thread clienteconectado"); //ajeitar isso depois
				e.printStackTrace();
			}
	}
}
