package pacoteServidor;
import java.util.*;
import java.io.*;


public class PingEAtualizar {
	
	private String nome;
	private Timer timer;
	private ConectarNovoCliente novoCliente;
	boolean estaConectado;
	private Ping ping;
	
	public PingEAtualizar(ConectarNovoCliente novoCliente, String nome){
		this.nome = nome;
		this.novoCliente = novoCliente;
		timer = new Timer();
		this.ping = new Ping();
		timer.schedule(ping,0,500); //executa a tarefa a cada 0,5 seg
	}
	
	public class Ping extends TimerTask {
		
		public void run() {
			//mandando um ping
			try {
				novoCliente.getSaida().write(1);
			} catch (IOException e1) {
				System.out.println("desconectou (msgm da classe PingEAtualizar)");
			}
			estaConectado = false;

			//iniciando a thread q espera a resposta e atualiza a lista do cliente.
			AtualizarOCliente atualizar = new AtualizarOCliente(this,novoCliente,nome);
			try {
				synchronized(this) {  
					wait(3000); //3 seg de timout, se n for respondido neste tempo ker dizer q o cliente desconectou
				}
			} catch (InterruptedException e) {
				System.out.println("erro no wait da classe Ping.");
			}
			if(!estaConectado){ //conectado so eh true se a thread 'atualizar' rodar ate o final sem problemas
				atualizar.interrupt();
				synchronized(novoCliente) {  
					novoCliente.notify(); //acordando a thread principal
				}
				timer.cancel();
			}

			
		}
		public boolean estaConectado() {
			return estaConectado;
		}

		public void setConectado(boolean conectado) {
			estaConectado = conectado;
		}
		
	}

}
