package pacoteServidor;

public class RepositorioUsuarios {

	private Usuario[] repositorio;
	private int tamanho;
	private int proxPosVaga;
	private int proxPorta; 
	//utilizado para atribuir portas de comunicaao aos usuarios
	//portas fixas por login, mudar isso depois se possivel!
	
	public RepositorioUsuarios(int tamanho){
		this.tamanho = tamanho;
		this.proxPosVaga = 0;
		this.repositorio = new Usuario[this.tamanho];
		this.proxPorta = 5001; //porta inicial
	}
	
	public void adicionarUsuario(String nome){
		int portaChat = this.proxPorta;
		this.proxPorta++;
		int portaDados = this.proxPorta;
		this.proxPorta++;
		int portaControle = this.proxPorta;
		this.proxPorta++;
		this.repositorio[this.proxPosVaga] = new Usuario(nome,portaChat,portaDados, portaControle);
		proxPosVaga++;
	}
	
	public void removerUsuario(String nome){
		if(this.existeUsuario(nome)){
			int posicao = this.procurar(nome);
			if(posicao != proxPosVaga-1){ //ker dizer q NAO eh o ultimo
				for(int i = posicao; i < proxPosVaga-1; i++){ //da um 'shift left' apagando 'nome'
					this.repositorio[i] = this.repositorio[i+1];
				}
			}
			proxPosVaga--; //se for o ultimo ele so decrementa proxPosVaga
		}
	}
	
	public void setHost(String nome, String host){ //nao botei p verificar existencia pois assumo q isto so sera
		int posicao = this.procurar(nome);		   //utilizado apos confirmacao de login do usuario.
		this.repositorio[posicao].setHost(host);
	}
	
	public String getHost(String nome){
		int posicao = this.procurar(nome);
		return this.repositorio[posicao].getHost();
	}
	
	//retorna o numero de usuarios conectados sem contar com 'nome'
	public int getNumConectados(String nome){
		int contador = 0;
		for(int i = 0; i < proxPosVaga; i++){
			if((this.repositorio[i].getHost() != null)
					&& !this.repositorio[i].getUser().equals(nome)){
				contador++;
			}
		}
		return contador;
	}
	
	//retorna todos os usuarios onlines, com excessao de 'nome'
	public Usuario[] getListaConectados(String nome){
		Usuario[] retorno = new Usuario[this.getNumConectados(nome)];
		int posicao = 0;
		for(int i = 0; i < proxPosVaga; i++){
			if(this.repositorio[i].getHost() != null  
					&& !this.repositorio[i].getUser().equals(nome)){
				retorno[posicao] = this.repositorio[i];
				posicao++;
			}
		}
		return retorno;
	}
	
	//retorna a posicao no array onde se encontra 'nome'
	//se nao encontrar retorna -1
	private int procurar(String nome){
		int posicaoAtual = 0;
		boolean encontrou = false;
		while(!encontrou && posicaoAtual < proxPosVaga){
			if(this.repositorio[posicaoAtual].getUser().equals(nome)){
				encontrou = true;
			}
			posicaoAtual++;
		}
		return posicaoAtual -1; // -1 pois no loop q ele encontra, ainda eh adicionado +1 a posicao.
	}
	
	public boolean existeUsuario(String nome){
		int posicaoAtual = 0;
		boolean encontrou = false;
		while(!encontrou && posicaoAtual < proxPosVaga){
			if(this.repositorio[posicaoAtual].getUser().equals(nome)){
				encontrou = true;
			}
			posicaoAtual++;
		}
		return encontrou;
	}
	public int getPortaChat(String nome){
		int posicao = procurar(nome);
		return this.repositorio[posicao].getPortaChat();
	}
	public int getPortaDados(String nome){
		int posicao = procurar(nome);
		return this.repositorio[posicao].getPortaDados();
	}
	public int getPortaControle(String nome){
		int posicao = procurar(nome);
		return this.repositorio[posicao].getPortaControle();
	}
	
	
}
