package pacoteServidor;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class Servidor {
	
	private RepositorioUsuarios repositorio;

	public Servidor(int numUsuarios){
		this.repositorio = new RepositorioUsuarios(numUsuarios);
	}
	
	public void rodar() throws IOException{
		ServerSocket welcomeSocket = new ServerSocket(5000);
		while(true) {
			Socket sock = welcomeSocket.accept();
			new ConectarNovoCliente(this,sock);
		}
	}
	
	public void adicionarUsuario(String nome){
		if(!this.repositorio.existeUsuario(nome))  //nao deixa inserir usuarios repetidos (login unico)
		this.repositorio.adicionarUsuario(nome);
	}
		public void removerUsuario(String nome){
		this.repositorio.removerUsuario(nome);
	}
	
	public RepositorioUsuarios getRepositorio(){
		return this.repositorio;
	}
	
	public void setHost(String nome,String host){
		this.repositorio.setHost(nome, host);
	}
	
	public String getHost(String nome){
		return this.repositorio.getHost(nome);
	}
	
	public boolean existeUsuario(String nome){
		return this.repositorio.existeUsuario(nome);
	}
	
	public int getNumConectados(String nome){
		return this.repositorio.getNumConectados(nome);
	}
	
	public Usuario[] getListaConectados(String nome){
		return this.repositorio.getListaConectados(nome);
	}
}
